#!/usr/bin/env python
import time
start = time.time()
import cgi
import cgitb
import zipfile
import re
import string
import subprocess
import os, sys
#cgitb.enable()
form = cgi.FieldStorage()

UPLOAD_DIR = "./tmp"

HTML_TEMPLATE = """<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>File Upload</title>
</head><body><h1>File Upload</h1>
<form action="?action=upload" method="POST" enctype="multipart/form-data">
File name: <input name="file" type="file"/><br/>
<input name="submit" type="submit"/>
</form>
</body>
</html>"""

UPLOAD_TEMPLATE = """<?xml version="1.0" encoding="ISO-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<html><head><title>Gallery View</title>
</head><body><h1>Gallery View</h1>
"""

HEADER = "content-type: text/html\n\n"

def error(text):
	print HEADER
	print "<html><body><h1>"+text+"</h1></body></html>"
	quit()
    
def getFilesWithSuffix(directory, suffix, notsuffix):
  fileList=os.listdir(directory)
  return [f for f in fileList if f.endswith(suffix) and not f.endswith(notsuffix)]

def processFile (form_field):
    """This saves a file uploaded by an HTML form.
    """
    if not form.has_key(form_field): return
    fileitem = form[form_field]
    if not fileitem.file: return
    filepath = os.path.join(UPLOAD_DIR, fileitem.filename)
    fout = file (filepath, 'wb')
    while 1:
        chunk = fileitem.file.read(100000)
        if not chunk: break
        fout.write (chunk)
    fout.close()
    return filepath

def unzip(file, path):
	fh = open(file, 'rb')
	z = zipfile.ZipFile(fh)
	for name in z.namelist():
			m = re.search('/([^/]*)$', name)
			if m == None: continue
			if not m.group(1): continue
			if (m.group(1).endswith('/')): continue
			outfile = open(os.path.join(path,m.group(1)), 'wb')
			outfile.write(z.read(name))
			outfile.close()
	fh.close()
	#os.remove(file) # remove zip file

def createThumbnails(path):
	for f in getFilesWithSuffix(path, '.jpg','_T.jpg'):
		inputfile = os.path.join(path,f)
		imageName = re.search('(.*)\.jpg$',f).group(1)
		outputfile = os.path.join(path,imageName+'_T.jpg')
		cmd = "/usr/local/bin/convert -resize 100x100 "+inputfile+" "+outputfile
		proc = subprocess.Popen(cmd, shell=True,stdout=subprocess.PIPE, stderr=subprocess.PIPE);
		returnValues = proc.communicate()
		if (proc.returncode==1): 
			os.remove(inputfile)
			continue 
	
def generateWebsite(path):
	html = UPLOAD_TEMPLATE
	for f in getFilesWithSuffix(path, '.jpg','_T.jpg'):
		inputfile = os.path.join(path,f)
		imageName = re.search('(.*)\.jpg$',f).group(1)
		outputfile = os.path.join(path,imageName+'_T.jpg')
		html += '<div class="image"><a href="'
		html += inputfile
		html += '"><img src="'
		html += outputfile
		html += '"/></a></div>'
	html += "Store file: %f seconds<br/>" % timeUpload;
	html += "Unzip file: %f seconds<br/>" % (timeUnzip-timeUpload);
	html += "Create thumbnails: %f seconds<br/>" % (timeThumbnails-timeUnzip);
	html += "Overall: %f seconds<br/>" % timeThumbnails;
	html += """</body></html>"""
	return html

if len(sys.argv)>=2:
	# wir haben ein command line argument!
	print sys.argv[1]
	filepath = sys.argv[1]
	timeUpload = time.time()-start;
	unzip(filepath, UPLOAD_DIR)
	timeUnzip = time.time()-start;
	createThumbnails(UPLOAD_DIR)
	timeThumbnails = time.time()-start;
	html = generateWebsite(UPLOAD_DIR)
	outfile = open('gallery.html', 'wb')
	outfile.write(html)
	outfile.close()
	quit()
else:
	if form.has_key("action") and form["action"].value == "upload":
		filepath = processFile ("file")
		timeUpload = time.time()-start;
		unzip(filepath, UPLOAD_DIR)
		timeUnzip = time.time()-start;
		createThumbnails(UPLOAD_DIR)
		timeThumbnails = time.time()-start;
		print HEADER
		print generateWebsite(UPLOAD_DIR)
		quit()
		
	print HEADER
	print HTML_TEMPLATE



